SystemOrganization addCategory: #'CS520-hm1'!

NamedBox subclass: #DancingBox
	instanceVariableNames: 'danceSpeed danceRoutine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DancingBox methodsFor: 'initialization' stamp: 'CameronRieck 1/13/2013 23:08'!
initialize
	"initializes the dancing box"
	super initialize.
	super stopStepping.
	danceRoutine := DanceRoutineNil new.
	danceSpeed := 0.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 23:06'!
setDanceRoutine: aDanceRoutine
	"sets the routine for the dancer"
	danceRoutine := aDanceRoutine.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 23:09'!
startDancing
	"moves the box according to a dance move"
	danceSpeed := 750.
	super startStepping.! !

!DancingBox methodsFor: 'private' stamp: 'CameronRieck 1/13/2013 23:10'!
step
	"implements what needs to be done during a dance step"
	| danceMove |
	super step.
	(danceSpeed > 0) ifTrue: 
		[
		danceMove := danceRoutine nextMove.
		danceMove do:self.
		]! !

!DancingBox methodsFor: 'private' stamp: 'CameronRieck 1/13/2013 19:55'!
stepTime
	"comment stating purpose of message"
	^ danceSpeed.! !

!DancingBox methodsFor: 'dancing' stamp: 'CameronRieck 1/13/2013 19:57'!
stopDancing
	"stops dancing"
	super stopStepping.
	danceSpeed := 0.! !

Object subclass: #DanceRoutine
	instanceVariableNames: 'routine currentRoutine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceRoutine methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:01'!
addDanceStep: danceStep
	"adds a dance step to the routine"
	routine add:danceStep.! !

!DanceRoutine methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:20'!
initialize
	routine := LinkedList new.
	currentRoutine := 1.! !

!DanceRoutine methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 21:55'!
nextMove
	"returns the next move to be performed in the routine"
	| theNextMove |
	theNextMove := routine at: currentRoutine.
	currentRoutine := currentRoutine + 1.
	(currentRoutine > routine size) ifTrue:
	[
		currentRoutine := 1.
	].
	^ theNextMove.! !

DanceRoutine subclass: #DanceRoutineNil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceRoutineNil methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:20'!
initialize
	super initialize.
	super addDanceStep:(DanceStepMove new setMove:0@0).! !

DanceRoutine subclass: #DanceRoutineSpin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceRoutineSpin methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:40'!
initialize
	super initialize.
	super addDanceStep: (DanceStepMove new setMove:0@20).
	super addDanceStep: (DanceStepMove new setMove:0@20).
	super addDanceStep: (DanceStepTurn new setTurn:45).
	super addDanceStep: (DanceStepTurn new setTurn:45).
	super addDanceStep: (DanceStepTurn new setTurn:(-45)).
	super addDanceStep: (DanceStepTurn new setTurn:(-45)).
	super addDanceStep: (DanceStepMove new setMove:0@(-20)).
	super addDanceStep: (DanceStepMove new setMove:0@(-20)).! !

DanceRoutine subclass: #DanceRoutineSquare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceRoutineSquare methodsFor: 'initialize' stamp: 'CameronRieck 1/13/2013 23:24'!
initialize
	super initialize.
	super addDanceStep: (DanceStepMove new setMove:0@20).
	super addDanceStep: (DanceStepMove new setMove:20@0).
	super addDanceStep: (DanceStepMove new setMove:0@(-20)).
	super addDanceStep: (DanceStepMove new setMove:(-20)@0).! !

DanceRoutine subclass: #DanceRoutineTwist
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceRoutineTwist methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:41'!
initialize
	super initialize.
	super addDanceStep: (DanceStepMove new setMove:20@0).
	super addDanceStep: (DanceStepMove new setMove:20@0).
	super addDanceStep: (DanceStepTurn new setTurn:45).
	super addDanceStep: (DanceStepMove new setMove:(-20)@0).
	super addDanceStep: (DanceStepMove new setMove:(-20)@0).
	super addDanceStep: (DanceStepTurn new setTurn:(-45)).! !

Object subclass: #DanceStep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceStep methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 22:00'!
do: dancer
	"performs the dance step on the dancer"
	! !

DanceStep subclass: #DanceStepMove
	instanceVariableNames: 'movement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceStepMove methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:32'!
do: dancer
	"performs the movement"
	dancer move:movement.! !

!DanceStepMove methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:18'!
setMove: newMovement
	"sets the move"
	movement := newMovement.
! !

DanceStep subclass: #DanceStepTurn
	instanceVariableNames: 'degreesToTurn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-hm1'!

!DanceStepTurn methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:31'!
do: dancer
	"performs the turn"
	dancer turn: degreesToTurn.! !

!DanceStepTurn methodsFor: 'as yet unclassified' stamp: 'CameronRieck 1/13/2013 23:30'!
setTurn: turnDegrees
	"sets the number of degrees to turn"
	degreesToTurn := turnDegrees.! !
